-- phpMyAdmin SQL Dump
-- version 3.2.2.1deb1
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Nov 12, 2009 at 05:15 PM
-- Server version: 5.1.37
-- PHP Version: 5.2.10-2ubuntu6

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";

--
-- Database: `inventory`
--

-- --------------------------------------------------------

--
-- Table structure for table `devices`
--

CREATE TABLE IF NOT EXISTS `devices` (
  `id` int(11) NOT NULL COMMENT 'universally unique id for device',
  `device_kind_id` int(11) NOT NULL COMMENT 'link to corresponding entry in device_kinds',
  `motherboard_id` int(11) DEFAULT NULL COMMENT 'link to corresponding entry in motherboards',
  `inventory_id` int(11) NOT NULL COMMENT 'link to corresponding entry in inventories',
  `address` varchar(18) NOT NULL COMMENT 'bus address of this device.  MUST sort lexically by bus',
  `mac` varchar(17) DEFAULT NULL COMMENT 'MAC address of this device, if it is a network device',
  `canonical_name` varchar(64) DEFAULT NULL COMMENT 'a good guess as to the name Linux will give to this device',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `devices`
--

INSERT INTO `devices` (`id`, `device_kind_id`, `motherboard_id`, `inventory_id`, `address`, `mac`, `canonical_name`) VALUES
(1, 1, 1, 1, '', '00:0e:0c:7f:08:0e', 'eth0'),
(3, 1, 3, 1, '', '00:0e:0c:7f:0e:8c', 'eth0'),
(4, 1, 4, 1, '', NULL, NULL),
(2, 1, 2, 1, '', '00:0e:0c:7f:0d:f3', 'eth0');

-- --------------------------------------------------------

--
-- Table structure for table `device_kinds`
--

CREATE TABLE IF NOT EXISTS `device_kinds` (
  `id` int(11) NOT NULL COMMENT 'universally unique id for device',
  `inventory_id` int(11) NOT NULL COMMENT 'the inventory when we caught this device type',
  `bus` varchar(16) DEFAULT NULL COMMENT 'e.g. pci or usb',
  `vendor` int(11) NOT NULL COMMENT 'id of vendor from /sys',
  `device` int(11) NOT NULL COMMENT 'id of device from /sys',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `device_kinds`
--


-- --------------------------------------------------------

--
-- Table structure for table `device_ouis`
--

CREATE TABLE IF NOT EXISTS `device_ouis` (
  `oui` char(8) NOT NULL COMMENT 'OUI as string XX:XX:XX',
  `device_kind_id` int(11) NOT NULL COMMENT 'link to corresponding entry in device_kinds',
  `inventory_id` int(11) DEFAULT NULL COMMENT 'if generated automatically, id of inventory run, otherwise NULL'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `device_ouis`
--


-- --------------------------------------------------------

--
-- Table structure for table `device_tags`
--

CREATE TABLE IF NOT EXISTS `device_tags` (
  `tag` varchar(64) NOT NULL COMMENT 'name for this tag',
  `device_kind_id` int(11) NOT NULL COMMENT 'link to corresponding entry in device_kinds',
  `inventory_id` int(11) DEFAULT NULL COMMENT 'if generated automatically, id of inventory run, otherwise NULL'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `device_tags`
--


-- --------------------------------------------------------

--
-- Table structure for table `inventories`
--

CREATE TABLE IF NOT EXISTS `inventories` (
  `id` int(11) NOT NULL COMMENT 'obligatiory unique id',
  `opened` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'start of inventory run',
  `closed` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'end of inventory run, or 0000-etc. if not done yet',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `inventories`
--

INSERT INTO `inventories` (`id`, `opened`, `closed`) VALUES
(1, '2008-08-28 20:45:12', '0000-00-00 00:00:00');

-- --------------------------------------------------------

--
-- Table structure for table `locations`
--

CREATE TABLE IF NOT EXISTS `locations` (
  `id` int(11) NOT NULL COMMENT 'universally unique id for location',
  `x` int(11) NOT NULL DEFAULT '0' COMMENT 'logical x address of location',
  `y` int(11) NOT NULL DEFAULT '0' COMMENT 'logical y address of location',
  `z` int(11) NOT NULL DEFAULT '0' COMMENT 'logical z address of location',
  `latitude` float DEFAULT NULL COMMENT 'latitude of this location or NULL',
  `longitude` float DEFAULT NULL COMMENT 'longitude of this location or NULL',
  `elevation` float DEFAULT NULL COMMENT 'elevation of this location or NULL',
  `testbed_id` int(11) NOT NULL,
  `name` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `locations`
--

INSERT INTO `locations` (`id`, `x`, `y`, `z`, `latitude`, `longitude`, `elevation`, `testbed_id`, `name`) VALUES
(3, 1, 3, 1, NULL, NULL, NULL, 1, 'Lab-Front-Left'),
(4, 1, 4, 1, NULL, NULL, NULL, 1, 'Lab-Rear-Left'),
(2, 1, 2, 1, NULL, NULL, NULL, 1, 'Lab-Front-Right'),
(1, 1, 1, 1, NULL, NULL, NULL, 1, 'Lab-Rear-Right');

-- --------------------------------------------------------

--
-- Table structure for table `motherboards`
--

CREATE TABLE IF NOT EXISTS `motherboards` (
  `id` int(11) NOT NULL COMMENT 'universally unique id for motherboard',
  `inventory_id` int(11) NOT NULL COMMENT 'link to corresponding entry in inventories',
  `mfr_sn` varchar(128) DEFAULT NULL COMMENT 'manufacturer serial number of the motherboard',
  `cpu_type` varchar(64) DEFAULT NULL COMMENT 'name of CPU as given by vendor',
  `cpu_n` int(11) DEFAULT NULL COMMENT 'number of CPUs',
  `cpu_hz` float DEFAULT NULL COMMENT 'CPU speed in MHz',
  `hd_sn` varchar(64) DEFAULT NULL COMMENT 'hard drive serial number, NULL if no hd',
  `hd_size` int(11) DEFAULT NULL COMMENT 'hard disk size in bytes',
  `hd_status` tinyint(1) DEFAULT '1' COMMENT 'true means drive probably okay',
  `memory` int(11) DEFAULT NULL COMMENT 'memory size in bytes',
  PRIMARY KEY (`id`),
  UNIQUE KEY `mfr_sn` (`mfr_sn`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `motherboards`
--

INSERT INTO `motherboards` (`id`, `inventory_id`, `mfr_sn`, `cpu_type`, `cpu_n`, `cpu_hz`, `hd_sn`, `hd_size`, `hd_status`, `memory`) VALUES
(1, 1, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL),
(2, 1, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL),
(3, 1, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL);

-- --------------------------------------------------------

--
-- Table structure for table `nodes`
--

CREATE TABLE IF NOT EXISTS `nodes` (
  `id` int(11) NOT NULL COMMENT 'universally unique id for nodes',
  `inventory_id` int(11) NOT NULL COMMENT 'link to corresponding entry in inventories',
  `chassis_sn` varchar(64) DEFAULT NULL COMMENT 'manufacturer serial number of the chassis of the node; optionally null',
  `motherboard_id` int(11) NOT NULL COMMENT 'the motherboard in this node',
  `location_id` int(11) DEFAULT NULL COMMENT 'the location of this node',
  `control_ip` varchar(64) DEFAULT NULL,
  `pxeimage_id` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `location_id` (`location_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `nodes`
--

INSERT INTO `nodes` (`id`, `inventory_id`, `chassis_sn`, `motherboard_id`, `location_id`, `control_ip`, `pxeimage_id`) VALUES
(2, 1, '1', 2, 2, '10.0.0.2', 1),
(3, 1, '1', 3, 3, '10.0.0.3', 1),
(4, 1, '1', 4, 4, '10.0.0.4', 1),
(1, 1, '1', 1, 1, '10.0.0.1', 1);

-- --------------------------------------------------------

--
-- Table structure for table `pxeimages`
--

CREATE TABLE IF NOT EXISTS `pxeimages` (
  `id` int(11) DEFAULT NULL,
  `image_name` varchar(64) DEFAULT NULL,
  `short_description` varchar(128) DEFAULT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `pxeimages`
--

INSERT INTO `pxeimages` (`id`, `image_name`, `short_description`) VALUES
(1, 'pxeconfig', 'latest PXE image');

-- --------------------------------------------------------

--
-- Table structure for table `testbeds`
--

CREATE TABLE IF NOT EXISTS `testbeds` (
  `id` int(11) NOT NULL COMMENT 'universally unique id for testbed',
  `node_domain` varchar(128) NOT NULL COMMENT 'example: grid',
  `x_max` int(11) DEFAULT NULL,
  `y_max` int(11) DEFAULT NULL,
  `z_max` int(11) DEFAULT NULL,
  `control_ip` varchar(64) DEFAULT NULL,
  `data_ip` varchar(64) DEFAULT NULL,
  `cm_ip` varchar(64) DEFAULT NULL,
  `latitude` float DEFAULT NULL COMMENT 'latitude of origin of node_domain or NULL',
  `longitude` float DEFAULT NULL COMMENT 'longitude of origin of node_domain or NULL',
  `elevation` float DEFAULT NULL COMMENT 'elevation of origin of node_domain or NULL',
  `pxe_url` varchar(64) DEFAULT NULL,
  `cmc_url` varchar(64) DEFAULT NULL,
  `oml_url` varchar(64) DEFAULT NULL,
  `result_url` varchar(64) DEFAULT NULL,
  `frisbee_url` varchar(64) DEFAULT NULL,
  `frisbee_default_disk` varchar(64) DEFAULT NULL,
  `saveimage_url` varchar(64) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `node_domain` (`node_domain`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `testbeds`
--

INSERT INTO `testbeds` (`id`, `node_domain`, `x_max`, `y_max`, `z_max`, `control_ip`, `data_ip`, `cm_ip`, `latitude`, `longitude`, `elevation`, `pxe_url`, `cmc_url`, `oml_url`, `result_url`, `frisbee_url`, `frisbee_default_disk`, `saveimage_url`) VALUES
(1, 'sandbox2', 1, 4, 1, '10.0.0.0', NULL, NULL, NULL, NULL, NULL, 'http://localhost:5052/pxe', 'http://localhost:5052/cmc', 'tcp:10.0.0.200:3003', 'http://localhost:5052/result', 'http://localhost:5052/frisbee', '/dev/hda', 'http://localhost:5052/saveimage'),
(2, 'test', 1, 4, 1, '10.0.0.0', NULL, NULL, NULL, NULL, NULL, 'http://localhost:5052/pxe', 'http://localhost:5052/cmc', 'tcp:10.0.0.200:3003', 'http://localhost:5052/result', 'http://localhost:5052/frisbee', '/dev/hda', 'http://localhost:5052/saveimage');
